/*****************************************************************************
//
//	File:			3dConvexModel.h
//
//	Description:    Class handling any convex 3d face model.
//
//	Copyright 1997, Be Incorporated
//
// The 3dKit is a fully object-oriented library, going from low-level 3d
// engine to high-level 3d API. The whole system is decomposed in functional
// blocks, that can include both high-level and low-level API. To allow all
// those classes to communicate smoothly and efficiently, most of their datas
// and methods are public. That can introduce some confusion in the sense that
// reading the headers will not allow developer to differenciate API levels
// by their protection only. That's why some comments were added in the key
// classes of the 3dKit to help you recognize which API you should use
// depending of the level of usage you want.
*****************************************************************************/

#ifndef _3D_CONVEX_MODEL_H
#define _3D_CONVEX_MODEL_H

#ifndef _3D_FACE_MODEL_H
#include "3dFaceModel.h"
#endif

/**************************************
// B3dConvexModel.
/*************************************/

class B3dConvexModel : public B3dFaceModel {

/*************************************
// LOW-LEVEL API                    */

 public:
	B3dConvexModel(B3dFaceModelDesc *desc, uint32 OwnFlag = 0);
	virtual void *Sort(B3dLensImage *lensImage, uint32 status, B3dSharedState *buf);
};

#endif

 






